/*
 *	ccryptgui, QT based graphical user interface to ccrypt
 *
 *	Copyright (C) 2011  Martin Hilscher
 *
 *	This program is free software; you can redistribute it and/or modify it under the
 *	terms of the GNU General Public License as published by theFree Software Foundation;
 *	either version 3 of the License, or (at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful, but WITHOUT ANY
 *	WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
 *	PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 *	You should have received a copy of the GNU General Public License along with this
 *	program; if not, see <http://www.gnu.org/licenses/>.
 *
 *	---------------------------------------------------------------------
 *
 *	ccrypt_exe.cpp -  execute crypt-functions
 */


#include "ccryptgui.h"

#ifdef WIN
   #include "direct.h"
   #include "process.h"
#else //LINUX
   #include "unistd.h"
   #include "sys/wait.h"
   #include "sys/stat.h"
#endif


  // Execute crypt

  // *****************************************************************************************************
  //
  //   Important: don't change value of local variable after you have created a pointer to this variable
  //
  // *****************************************************************************************************
  void CCryptGui::crypt_exe ( )
  {

     QByteArray pwd;
     QByteArray file;
     QByteArray files;

     char*  cmd;
     char** argv;

     QByteArray temp, para1, para2;

     int err        = 0;
     int cnt_err    = 0;
     int cnt_cpt;
     int cnt_para;


     pwd  = (ui_pwd->lineEdit->text()).toAscii();


     if ( crypt_mode == CRYPT_MODE_ENCRYPT )
     {
        argv = ptr_cmd_encrypt_args;

        cnt_para = n_cmd_encrypt_args;

        temp = (ui_pwd->lineEditC->text()).toAscii();
        if ( ! ( pwd == temp ) )
        {
           write_messages( "** ERROR: Passwords does not match!" );
           enable_buttons();
           return;
        }

     }
     else // (( crypt_mode == CRYPT_MODE_DECRYPT ) || ( crypt_mode == CRYPT_MODE_OPEN ))
     {
        argv = ptr_cmd_decrypt_args;

        cnt_para = n_cmd_decrypt_args;

     }


     para1 = "-K";
     *( argv + (cnt_para++) ) = para1.data();
     *( argv + (cnt_para++) ) = pwd.data();


     if ( filedialog_mode == FILE_DIALOG_DIR_MODE )
     {
        para2 = "-r";
        *( argv + (cnt_para++) ) = para2.data();
        files = "Directory";
     }
     else
     {
        files = "Files(s)";
     }


     char** ppstr_file        = argv + (cnt_para++); // only pointer allocated, value will be stored later 
     *( argv + (cnt_para++) ) = NULL;

     if ( crypt_mode == CRYPT_MODE_ENCRYPT )
        cmd = cmd_encrypt_args.data();
     else
        cmd = cmd_decrypt_args.data();

     // Delete passwort input box
     ui_pwd->lineEdit->clear();
     ui_pwd->lineEditC->clear();


     for ( cnt_cpt = 0; cnt_cpt < n_files; cnt_cpt++ )
     {
#ifdef WIN
        file  = "\"";
        file += (filelist.value(cnt_cpt)).toAscii();
        file += "\"";
#else
        file  = (filelist.value(cnt_cpt)).toAscii();
#endif
        *( ppstr_file ) = file.data();


        err = call_app( cmd, argv, cmd );


        if ( err )
        {
           cnt_err++;
           err_ccrypt = err;
           temp  = file;
           temp += ": ERROR ";
           temp += QByteArray::number( err );
        }
        else
        {
           temp =  file;
           temp += ": OK";
        }

        write_messages( temp.data() );
        ui_main->progressBar->setValue(cnt_cpt + 2);

     }

     write_messages("  ----" );
  
     temp =  QByteArray::number( cnt_cpt-cnt_err );
     temp += " of ";
     temp += QByteArray::number( n_files );
     temp += " ";
     temp += files;
     if ( crypt_mode == CRYPT_MODE_ENCRYPT )
     {
        temp += ": successfully encrypted";
     }
     else // (( crypt_mode == CRYPT_MODE_DECRYPT ) || ( crypt_mode == CRYPT_MODE_OPEN ))
     {
        temp += ": successfully decrypted";
     }

     write_messages( temp.data() );

     if ( cnt_err )
     {
        temp =  QByteArray::number( cnt_err );
        temp += " of ";
        temp += QByteArray::number( n_files );
        temp += " ";
        temp += files;
        temp += ": error(s) occured";
	write_messages( temp.data() );
     }

  }



